package main.java;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

/**
 * Created with IntelliJ IDEA.
 * User: Geir
 * Date: 2/8/14
 * Time: 12:26
 * To change this template use File | Settings | File Templates.
 */
public class NeighbouringTerms {
    private Map<String, Integer> cooccurrenceMatrix = new HashMap<String, Integer>();

    public NeighbouringTerms(List<String> abstracts) throws IOException {
        String termOne;
        String termTwo;
        for(String line: abstracts){
            String[] terms = line.split(" ");
            for(int i = 0; i < terms.length-1; i++){
                if(terms[i].contains("/") ||
                        terms[i].contains("\\") ||
                        terms[i].contains("{") ||
                        terms[i].contains("}") ||
                        terms[i].contains("=") ||
                        terms[i].contains("<")){
                    continue;
                }
                else if(terms[i+1].contains("/") ||
                        terms[i+1].contains("\\") ||
                        terms[i+1].contains("{") ||
                        terms[i+1].contains("}") ||
                        terms[i+1].contains("=") ||
                        terms[i+1].contains("<")) {
                    continue;
                }
                else if(Utils.containsDigits(terms[i]) || Utils.containsDigits(terms[i+1])){
                    continue;
                }

                termOne = terms[i];
                termTwo = terms[i+1];
                int occurrence;
                if(termOne.compareToIgnoreCase(termTwo) < 0){
                    Bigram bigram = new Bigram(termOne, termTwo);
                    if(!cooccurrenceMatrix.containsKey(bigram.toString())){
                        cooccurrenceMatrix.put(bigram.toString(),0);
                    }
                    occurrence = cooccurrenceMatrix.get(bigram.toString()) + 1;
                    cooccurrenceMatrix.put(bigram.toString(), occurrence);
                }
                else{
                    Bigram bigram = new Bigram(termTwo, termOne);
                    if(!cooccurrenceMatrix.containsKey(bigram)){
                        cooccurrenceMatrix.put(bigram.toString(),0);
                    }
                    occurrence = cooccurrenceMatrix.get(bigram.toString()) + 1;
                    cooccurrenceMatrix.put(bigram.toString(), occurrence);
                }
            }
        }
    }

    public void sort(){
        IntValueComparator comparator = new IntValueComparator(cooccurrenceMatrix);
        TreeMap<String, Integer> sortedMap = new TreeMap<String, Integer>(comparator);
        sortedMap.putAll(cooccurrenceMatrix);
        cooccurrenceMatrix = sortedMap;
    }

    public void print(){
        for(Map.Entry<String, Integer> entry: cooccurrenceMatrix.entrySet()){
            System.out.println(entry.getKey() + ": " + entry.getValue());
        }
    }

    public List<String> returnTopNTerms(String query, int n){
        int iterator = 1;
        List<String> terms = new ArrayList<String>();
        terms.add(query);
        for(String bigram: cooccurrenceMatrix.keySet()){
            String[] words = bigram.split(" ");
            if(!terms.contains(words[0])){
                terms.add(words[0]);
                iterator++;
            }
            if(!terms.contains(words[1])){
                terms.add(words[1]);
                iterator++;
            }
            if(iterator >= n+1){
                break;
            }
        }
        return terms;
    }
}
