package main.java;

import org.apache.lucene.queryparser.classic.ParseException;

import javax.swing.*;
import java.io.IOException;
import java.util.List;

public class QueryExpandedTagRetrieval {

    public static final int maxNumberOfExpansionTags = 5;
    public static final int maxNumberOfArticles = 150;
    public static final int maxNumberOfImages = 10;

    public static void main(String[] args) throws IOException, ParseException {
        //Methods for building index
        //IndexConstructor.ProcessAbstracts();
        //IndexConstructor.ProcessTags();

        //Utils.printUniqueTerms("cumulus surface america visible common altitude ground computing north served character observations temperature released level american generally vapor develop published light formation water clouds limit observation national depend atmosphere observed planets system article precipitation service cloud aerosols dense release small based large produce occur cumulus surface america physics common altitude ground computing served character observations temperature released level american generally vapor report develop published light formation clouds water limit connection observation depend atmosphere stratus solar system article hydrogen precipitation service cloud dense release small based large produce occur cumulus surface america physics density common altitude ground served troposphere character observations temperature released level american interstellar generally vapor report weather develop light formation limit water clouds structure connection observation depend shape system article ratio precipitation popular service cloud release small based large produce occur");
        //Eval cloud = new Eval("/Users/Geir/Development/master/src/main/resources/survey/clouds.txt");
        //Eval cat = new Eval("/Users/Geir/Development/master/src/main/resources/survey/cat.txt");
        //Eval weapon = new Eval("/Users/Geir/Development/master/src/main/resources/survey/weapon.txt");
        //Eval school = new Eval("/Users/Geir/Development/master/src/main/resources/survey/school.txt");
        //Eval police = new Eval("/Users/Geir/Development/master/src/main/resources/survey/police.txt");
        //Eval fruit = new Eval("/Users/Geir/Development/master/src/main/resources/survey/fruit.txt");
        //Eval meat = new Eval("/Users/Geir/Development/master/src/main/resources/survey/meat.txt");
        //Eval telephone = new Eval("/Users/Geir/Development/master/src/main/resources/survey/telephone.txt");
        //Eval machine = new Eval("/Users/Geir/Development/master/src/main/resources/survey/machine.txt");
        //Eval computer = new Eval("/Users/Geir/Development/master/src/main/resources/survey/computer.txt");
        //Eval space = new Eval("/Users/Geir/Development/master/src/main/resources/survey/space.txt");
        //Eval game = new Eval("/Users/Geir/Development/master/src/main/resources/survey/game.txt");
        //Eval power = new Eval("/Users/Geir/Development/master/src/main/resources/survey/power.txt");
        //Eval piano = new Eval("/Users/Geir/Development/master/src/main/resources/survey/piano.txt");
        //Eval moon = new Eval("/Users/Geir/Development/master/src/main/resources/survey/moon.txt");
        //Eval screen = new Eval("/Users/Geir/Development/master/src/main/resources/survey/screen.txt");
        //Eval car = new Eval("/Users/Geir/Development/master/src/main/resources/survey/car.txt");
        //Eval book = new Eval("/Users/Geir/Development/master/src/main/resources/survey/book.txt");
        //Eval bike = new Eval("/Users/Geir/Development/master/src/main/resources/survey/bike.txt");
        //Eval soldier = new Eval("/Users/Geir/Development/master/src/main/resources/survey/soldier.txt");

        //searchByMostFrequentTerms();
        //List<String> results = searchByCSMI("soldier"); //Cooccurrence with Mutual Information calculation
        //List<String> results = searchByNT("cloud"); //Cooccurrence where only neighbouring terms are counted

        //searchByCSMI(); //Cooccurrence with Mutual Information calculation
        searchByNT(); //Cooccurrence where only neighbouring terms are counted

        /*for(String term: results){
            double value;
            try{
                value = cloud.getCloud().get(term);
            }catch(NullPointerException e){
                value = 0.0;
            }
            System.out.println(term + "\t" + (value / 10));
        }*/
        //System.exit(0);
    }

    private static void searchByMostFrequentTerms() throws ParseException, IOException{
        JFrame frame = new JFrame("Hyperlinked tag query expansion");

        //Search parameter
        String query = JOptionPane.showInputDialog(frame, "Input one tag");

        //Build hyponym hierarchy
        //Set<String> hyponymHierarchy = Utils.buildHyponymHierarchy(query, hyponymHierarchyLevel);

        List<String> abstractResult = Searcher.searchAbstracts(query, maxNumberOfArticles);
        List<String> listOfWords = Utils.splitWords(abstractResult);
        List<String> listOfRankedAbstracts = Utils.sortListByFrequency(listOfWords, maxNumberOfExpansionTags);

        String tagSearchString = Utils.listToString(listOfRankedAbstracts);
        System.out.println("SEARCH for " + query + " WITH KEYWORDS: \n" + tagSearchString);
        Searcher.searchTags(tagSearchString, maxNumberOfImages, false);
    }

    private static void searchByCSMI() throws ParseException, IOException {
        JFrame frame = new JFrame("Hyperlinked tag query expansion");

        //Search parameter
        String query = JOptionPane.showInputDialog(frame, "Input one tag");

        //for(Queries query: Queries.values()){

        List<String> abstractResult = Searcher.searchAbstracts(query, maxNumberOfArticles);

        ChiSquareMutualInformation coOccurrenceMatrix = new ChiSquareMutualInformation(abstractResult);
        coOccurrenceMatrix.sortMatrix();
        //coOccurrenceMatrix.printMatrix();

        List<String> cooccurringTerms = coOccurrenceMatrix.getNTopTerms(maxNumberOfExpansionTags, query);

        String tagSearchString = Utils.listToString(cooccurringTerms);
        System.out.println(tagSearchString);
        Searcher.searchTags(tagSearchString, maxNumberOfImages, true);
        //}
    }

    private static void searchByNT() throws ParseException, IOException {
        JFrame frame = new JFrame("Hyperlinked tag query expansion");

        //Search parameter
        String query = JOptionPane.showInputDialog(frame, "Input one tag");
        //for(Queries query: Queries.values()){

        List<String> abstractResult = Searcher.searchAbstracts(query, maxNumberOfArticles);

        NeighbouringTerms coOccurrenceMatrix = new NeighbouringTerms(abstractResult);
        coOccurrenceMatrix.sort();
        //coOccurrenceMatrix.print();

        List<String> cooccurringTerms = coOccurrenceMatrix.returnTopNTerms(query, maxNumberOfExpansionTags);
        String tagSearchString = Utils.listToString(cooccurringTerms);
        Searcher.searchTags(tagSearchString, maxNumberOfImages, true);
        //}
    }
}
